/*
 * CRXThread.h
 */

#ifdef _WIN32
# include <windows.h>
# include <process.h>
# define CRX_THREAD_TYPE			void
#else
# include <pthread.h>
# define CRX_THREAD_TYPE			void *
#endif

class CRXThread
{
private:
	bool				mIsThreadRunnable;

	CRX_THREAD_TYPE		(* mCallback) (void * aArgs);
	void				* mThreadArg;

public:
	CRXThread			(void);

public:
	void	Create		(void);

	int		Run			(void);
	void	Stop		(void);
	void	SetRunnable	(bool aIsRunnable);
	bool	IsRunnable	(void) const;
};


