
#include "CRXMutex.h"

CRXMutex::CRXMutex (void)
{
#ifdef _WIN32
	mMutex = NULL;
#endif
}

CRXMutex::~CRXMutex (void)
{
	this->Unlock ();
#ifdef _WIN32
#else
#endif
}

int CRXMutex::Create ()
{
#ifdef _WIN32
	if ((mMutex = ::CreateMutexA(NULL, FALSE, NULL)) == NULL)
		return -1;
#else
	pthread_mutex_init (&mMutex, NULL);
#endif

	return 0;
}

void CRXMutex::Lock (void)
{
#ifdef _WIN32
	::WaitForSingleObject (mMutex, INFINITE);
#else
	pthread_mutex_lock (&mMutex);
#endif
}

void CRXMutex::Unlock (void)
{
#ifdef _WIN32
	if (mMutex != NULL)
		::ReleaseMutex(mMutex);
#else
	pthread_mutex_unlock (&mMutex);
#endif
}
